var F = Object.defineProperty;
var I = (n, t, e) => t in n ? F(n, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : n[t] = e;
var c = (n, t, e) => (I(n, typeof t != "symbol" ? t + "" : t, e), e);
import { ViewPlugin as m, Decoration as u, WidgetType as k, keymap as b } from "@codemirror/view";
import { StateField as w, StateEffect as C, Prec as D, EditorSelection as h } from "@codemirror/state";
import { debounceAsyncGenerator as y } from "./lib/utils.js";
const r = w.define({
  create() {
    return { suggestion: null };
  },
  update(n, t) {
    const e = t.effects.find(
      (s) => s.is(d)
    );
    return t.state.doc && e && (e.value.doc == null || t.state.doc == e.value.doc) ? { suggestion: e.value.suggestion } : { suggestion: null };
  }
}), d = C.define();
function E(n, t) {
  const e = n.state.selection.main.head, s = [], o = u.widget({
    widget: new P(t),
    side: 1
  });
  return s.push(o.range(e)), u.set(s);
}
class P extends k {
  constructor(e) {
    super();
    c(this, "suggestion");
    this.suggestion = e;
  }
  toDOM() {
    const e = document.createElement("span");
    return e.style.opacity = "0.4", e.className = "cm-inline-suggestion", e.textContent = this.suggestion, e;
  }
}
const g = (n) => {
  let t = 0;
  m.fromClass(
    class {
      async update(s) {
        const o = s.state.doc;
        if (!s.docChanged)
          return;
        const i = ++t;
        for await (const a of n(s.state)) {
          if (i != t)
            return;
          s.view.dispatch({
            effects: d.of({
              suggestion: a,
              doc: o
            })
          });
        }
      }
    }
  );
};
class T {
  constructor() {
    c(this, "decorations");
    this.decorations = u.none;
  }
  update(t) {
    var s;
    const e = (s = t.state.field(
      r
    )) == null ? void 0 : s.suggestion;
    if (!e) {
      this.decorations = u.none;
      return;
    }
    this.decorations = E(
      t.view,
      e.display_suggestion
    );
  }
}
const l = m.fromClass(T, {
  decorations: (n) => n.decorations
});
class _ {
  constructor(t, e) {
    c(this, "suggestFn");
    c(this, "keymap");
    c(this, "completionId");
    c(this, "run", (t) => {
      var o, i;
      const e = (o = t.state.field(
        r
      )) == null ? void 0 : o.suggestion;
      return e ? (t.dispatch({
        ...x(
          t.state,
          e.complete_suggestion,
          t.state.selection.main.head,
          t.state.selection.main.head
        )
      }), (i = e.accept_hook) == null || i.call(e), (async () => {
        if (this.suggestFn == null)
          return;
        const a = ++this.completionId;
        for await (const f of this.suggestFn(t.state)) {
          if (a != this.completionId)
            return;
          t.dispatch({
            effects: d.of({
              suggestion: {
                complete_suggestion: f.complete_suggestion,
                display_suggestion: f.display_suggestion,
                accept_hook: f.accept_hook
              },
              doc: null
            })
          });
        }
      })(), !0) : !1;
    });
    this.suggestFn = t, this.keymap = D.highest(
      b.of([
        {
          key: e,
          run: (s) => this.run(s)
        }
      ])
    ), this.completionId = 0;
  }
}
function x(n, t, e, s) {
  return {
    ...n.changeByRange((o) => {
      if (o == n.selection.main)
        return {
          changes: { from: e, to: s, insert: t },
          range: h.cursor(e + t.length)
        };
      const i = s - e;
      return !o.empty || i && n.sliceDoc(o.from - i, o.from) != n.sliceDoc(e, s) ? { range: o } : {
        changes: { from: o.from - i, to: o.from, insert: t },
        range: h.cursor(o.from - i + t.length)
      };
    }),
    userEvent: "input.complete"
  };
}
function p(n) {
  return typeof n == "string" ? {
    complete_suggestion: n,
    display_suggestion: n
  } : n;
}
function S(n) {
  return async function* (t) {
    const e = await n(t);
    if (typeof e == "string" || "complete_suggestion" in e) {
      yield p(e);
      return;
    }
    for await (const s of e)
      yield p(s);
  };
}
function G(n) {
  const { delay: t = 500, accept_shortcut: e = "Tab" } = n, s = S(n.fetchFn), { debounced: o } = y(
    s,
    t
  );
  return e ? [
    r,
    g(o),
    l,
    new _(
      n.continue_suggesting ? s : null,
      e
    ).keymap
  ] : [
    r,
    g(o),
    l
  ];
}
function K(n) {
  const { delay: t = 500, accept_shortcut: e = "Tab" } = n, s = S(n.fetchFn), { debounced: o, force: i } = y(s, t);
  return {
    extension: e ? [
      r,
      g(o),
      l,
      new _(
        n.continue_suggesting ? s : null,
        e
      ).keymap
    ] : [
      r,
      g(o),
      l
    ],
    force_fetch: i
  };
}
export {
  g as fetchSuggestion,
  K as forceableInlineSuggestion,
  G as inlineSuggestion
};
//# sourceMappingURL=extension.js.map
